"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs-promise");
var path = require("path");
var mkdirp = require("mkdirp");
var p_iteration_1 = require("p-iteration");
var index_1 = require("./processing/avatarCustomization/index");
var index_2 = require("./processing/move/index");
var index_3 = require("./processing/pokemon/index");
var index_4 = require("./processing/type/index");
var chalk_1 = require("chalk");
var index_5 = require("./processing/item/index");
var pokemonLocalesPipeline_1 = require("./processing/pokemon/locales/pokemonLocalesPipeline");
var moveLocalesPipeline_1 = require("./processing/move/locales/moveLocalesPipeline");
var itemLocalesPipeline_1 = require("./processing/item/locales/itemLocalesPipeline");
var index_6 = require("./processing/avatarCustomization/locales/index");
var gameMaster = require('../pokemongo-game-master/versions/latest/GAME_MASTER.json');
var specialGameMastersDirectory = path.resolve(__dirname, '../pokemongo-game-master/special');
var specialGameMasters = fs.existsSync(specialGameMastersDirectory) ? fs.readdirSync(specialGameMastersDirectory).map(function (file) { return require("../pokemongo-game-master/special/" + file); }) : [];
var packageJson = require('../package.json');
var POKEMON_TRANSLATIONS = require('./data/POKEMON_TRANSLATIONS.json');
var MOVES_TRANSLATIONS = require('./data/MOVES_TRANSLATIONS.json');
var ITEMS_TRANSLATIONS = require('./data/ITEMS_TRANSLATIONS.json');
var LOCALES = ['de-DE', 'en-US', 'zh-TW', 'fr-FR', 'es-ES', 'ja-JP', 'it-IT', 'ko-KR', 'pt-BR'];
var done = function (err, name) {
    return err ?
        console.log(chalk_1.default.red('✘') + " Error while writing " + name + ":") :
        console.log(chalk_1.default.green('✔') + " Successfully written " + name);
};
var write = function (file, pipeline, name) { return __awaiter(_this, void 0, void 0, function () {
    var data, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, pipeline.Run()];
            case 1:
                data = _a.sent();
                return [3 /*break*/, 3];
            case 2:
                err_1 = _a.sent();
                done(err_1, name);
                return [3 /*break*/, 3];
            case 3:
                fs.writeFile(file, JSON.stringify(data, null, 4), function (err) { return done(err, name); });
                return [2 /*return*/, data];
        }
    });
}); };
var writeTranslations = function (file, pipeline, name) { return __awaiter(_this, void 0, void 0, function () {
    var translations, err_2;
    var _this = this;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, pipeline.Run()];
            case 1:
                translations = _a.sent();
                return [3 /*break*/, 3];
            case 2:
                err_2 = _a.sent();
                done(err_2, name);
                return [3 /*break*/, 3];
            case 3:
                p_iteration_1.forEachSeries(translations, function (translation) { return __awaiter(_this, void 0, void 0, function () {
                    var folder, folderExists;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                folder = "./output/locales/" + translation.name;
                                return [4 /*yield*/, fs.exists(folder)];
                            case 1:
                                folderExists = _a.sent();
                                if (!folderExists) {
                                    mkdirp.sync(folder);
                                }
                                return [4 /*yield*/, fs.writeFile(path.join(folder, file), JSON.stringify(translation.data, null, 4))];
                            case 2:
                                _a.sent();
                                done(null, name + " " + translation.name);
                                return [2 /*return*/];
                        }
                    });
                }); });
                return [2 /*return*/];
        }
    });
}); };
console.log(chalk_1.default.blue('i') + " " + packageJson.name + " " + chalk_1.default.cyan(packageJson.version) + " ");
console.log(chalk_1.default.blue('i') + " Using GAME_MASTER version " + chalk_1.default.cyan(gameMaster.version));
var writePokemon = function () { return __awaiter(_this, void 0, void 0, function () {
    var pokemons, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4 /*yield*/, write('./output/pokemon.json', new index_3.PokemonPipeline(gameMaster, specialGameMasters), 'Pokemons')];
            case 1:
                pokemons = _c.sent();
                _a = writeTranslations;
                _b = ['pokemon.json'];
                return [4 /*yield*/, new pokemonLocalesPipeline_1.PokemonLocalesPipeline(POKEMON_TRANSLATIONS, pokemons, LOCALES)];
            case 2:
                _a.apply(void 0, _b.concat([_c.sent(), 'Pokemon Translations']));
                return [2 /*return*/];
        }
    });
}); };
var writeMoves = function () { return __awaiter(_this, void 0, void 0, function () {
    var moves;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, write('./output/move.json', new index_2.MovePipeline(gameMaster), 'Moves')];
            case 1:
                moves = _a.sent();
                writeTranslations('move.json', new moveLocalesPipeline_1.MoveLocalesPipeline(MOVES_TRANSLATIONS, moves, LOCALES), 'Moves Translations');
                return [2 /*return*/];
        }
    });
}); };
var writeItems = function () { return __awaiter(_this, void 0, void 0, function () {
    var items;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, write('./output/item.json', new index_5.ItemPipeline(gameMaster), 'Items')];
            case 1:
                items = _a.sent();
                writeTranslations('item.json', new itemLocalesPipeline_1.ItemLocalesPipeline(ITEMS_TRANSLATIONS, items, LOCALES), 'Items Translations');
                return [2 /*return*/];
        }
    });
}); };
var writeAvatarCusomization = function () { return __awaiter(_this, void 0, void 0, function () {
    var avatarCustomization;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, write('./output/avatar-customization.json', new index_1.AvatarCustomizationPipeline(gameMaster), 'Avatar Customizations')];
            case 1:
                avatarCustomization = _a.sent();
                writeTranslations('avatar-customization.json', new index_6.AvatarCustomizationLocalesPipeline(ITEMS_TRANSLATIONS, avatarCustomization, LOCALES), 'Avatar Customizations Translations');
                return [2 /*return*/];
        }
    });
}); };
writePokemon();
writeMoves();
writeItems();
writeAvatarCusomization();
write('./output/type.json', new index_4.TypePipeline(gameMaster), 'Types');
//# sourceMappingURL=app.js.map