"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var registry_1 = require("./registry");
/**
 * The type of the component
 */
var ComponentType;
(function (ComponentType) {
    /**
     * Simple maps are used for components which only require
     * a single item.
     */
    ComponentType[ComponentType["SIMPLE_MAP"] = 0] = "SIMPLE_MAP";
    /**
     * Advanced maps are used for components which requires
     * more than one item.
     */
    ComponentType[ComponentType["ADVANCED_MAP"] = 1] = "ADVANCED_MAP";
})(ComponentType = exports.ComponentType || (exports.ComponentType = {}));
/**
 * Registers a component
 * @param settings The settings of the component
 */
function Component(settings) {
    // Default values
    settings.type = settings.type || ComponentType.SIMPLE_MAP;
    return function (target) {
        var component = Object.create(target.prototype);
        registry_1.ComponentRegistry.Instance.Register(component, settings);
    };
}
exports.Component = Component;
//# sourceMappingURL=component.js.map