import { IPipeline } from '@core';
import { Translation } from '@income';
import { Locale } from '@outcome/locales/locale.interface';
export declare type GetKey<E> = (entity: E) => string;
export declare abstract class LocalesPipeline<E, T> implements IPipeline {
    protected translations: Translation[];
    protected entities: E[];
    protected locales: string[];
    protected getKey: GetKey<E>;
    constructor(translations: Translation[], entities: E[], locales: string[], getKey: GetKey<E>);
    protected getTranslationByKey(key: string): Translation;
    protected mapLocales(translation: Translation, localeName: string): string;
    protected generateLocaleByKey(key: string, localeName: string): any;
    abstract mapData(translation: T, entity: E, localeName: string): any;
    private getLocaleByName;
    Run(): Promise<Locale<T>[]>;
}
