export declare class AvatarCustomization {
    /**
     * If it is enabled in the shop or not
     */
    enabled: boolean;
    /**
     * For which gender the customization is
     * @example
     * "male"
     * "female"
     */
    gender: string;
    /**
     * In which slot the customization can be used
     * @example
     * "Shoes", "Shirt", "Belt", ...
     */
    slot: string[];
    /**
     * The name of the Avatar Customization
     */
    name: string;
    /**
     * The unique identification
     * @example
     * "f_shirt_tshirt_pikachu_6"
     */
    id: string;
    /**
     * When the player unlocks this customization
     * @example
     * 30
     */
    unlockPlayerLevel: number;
    /**
     * In which category this customization is
     * @example
     * "Shirt", "Shoes"
     */
    category: string;
    /**
     * The level to unlock the badge
     * @example
     * 10
     */
    unlockBadgeLevel?: number;
    /**
     * The name of the icon
     * @example
     * f_gloves_battlegirl_bundle_icon
     */
    iconName: string;
}
