"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var pipeline_1 = require("@core/pipeline");
/**
 * Represents the Pipeline which converts Game Master Avatar Customization related
 * input data to AvatarCustomization models
 */
var AvatarCustomizationPipeline = /** @class */ (function (_super) {
    __extends(AvatarCustomizationPipeline, _super);
    function AvatarCustomizationPipeline(input) {
        return _super.call(this, input, 'avatarCustomization') || this;
    }
    /**
     * Checks if the given ItemTemplate is indeed an avatar customization
     */
    AvatarCustomizationPipeline.prototype.isItemTemplate = function (item) {
        return new RegExp('^(AVATAR_?.*)', 'g').test(item.templateId);
    };
    return AvatarCustomizationPipeline;
}(pipeline_1.Pipeline));
exports.AvatarCustomizationPipeline = AvatarCustomizationPipeline;
//# sourceMappingURL=avatarCustomizationPipeline.js.map