"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var pipeline_1 = require("@core/pipeline");
var Gender = /** @class */ (function () {
    function Gender() {
    }
    /**
     * Parses the Gender out of a templateId-string
     * @param input The avatarCostumization templateId
     * @returns {Gender} The gender parsed out of the given templateId string
     * @example
     * new GenderParser().Process('AVATAR_m_hat_default_3'); // Gender.Male;
     * new GenderParser().Process('AVATAR_f_hat_default_3'); // Gender.Female;
     */
    Gender.prototype.Process = function (avatarCustomization, rawAvatarCustomzation) {
        var match = new RegExp('AVATAR_(.)_?.*', 'g').exec(rawAvatarCustomzation.templateId);
        var genderOutput;
        switch (match[1]) {
            case 'f':
                genderOutput = 'Female';
                break;
            case 'm':
                genderOutput = 'Male';
                break;
            default:
                throw 'Gender could not get identified';
        }
        avatarCustomization.gender = genderOutput;
        return avatarCustomization;
    };
    Gender = __decorate([
        pipeline_1.Component({
            pipeline: 'avatarCustomization'
        })
    ], Gender);
    return Gender;
}());
exports.Gender = Gender;
//# sourceMappingURL=gender.js.map