import { IComponent } from '@core/pipeline/component';
import { Pokemon } from '@outcome/pokemon';
import { ItemTemplate } from '@income';
export declare class FutureBranches implements IComponent {
    rawPokemons: ItemTemplate[];
    /**
     * Returns the future evolutions from the given GAME_MASTER data.
     * @param pokemonId The id of the pokemon
     */
    private GetFutureRawEvolutions;
    /**
     * Returns the cost for the evolution of the Pokemon
     * @param pokemonId The id of the pokemon you want to have the evolution cost
     * @param rawPokemon The GAME_MASTER provided raw pokemon of the lower evolution branch
     */
    private GetEvolutionCost;
    /**
     * Get the raw GAME_MASTER pokemon by id
     * @param pokemonId The pokemon id
     */
    private GetRawPokemonById;
    /**
     * Recursively gets all future branches from the given pokemon
     * @param pokemonId The id of the pokemon
     */
    private GetFutureBranches;
    Process(pokemons: Pokemon[], rawPokemons: ItemTemplate[]): Pokemon[];
}
