import { IComponent } from '@core/pipeline/component';
import { Pokemon } from '@outcome/pokemon/index';
import { ItemTemplate } from '@income/index';
export declare class PastBranches implements IComponent {
    rawPokemons: ItemTemplate[];
    /**
     * Get the raw GAME_MASTER pokemon by id
     * @param pokemonId The pokemon id
     */
    private GetRawPokemonById;
    /**
     * Returns the previous evolution from the given GAME_MASTER data.
     * @param pokemonId The id of the pokemon
     */
    private GetPreviousRawEvolution;
    /**
     * Returns the cost for the evolution of the Pokemon
     * @param pokemonId The id of the pokemon you want to have the evolution cost
     * @param rawPokemon The GAME_MASTER provided raw pokemon of the lower evolution branch
     */
    private GetEvolutionCost;
    /**
     * Recursively gets all past branches from the given pokemon
     * @param pokemonId The id of the pokemon
     * @param rawPokemons All raw GAME_MASTER pokemons
     */
    private GetPastBranch;
    Process(pokemons: Pokemon[], rawPokemons: ItemTemplate[]): Pokemon[];
}
