"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var pipeline_1 = require("@core/pipeline");
var _util_1 = require("@util");
var leftPad = require("left-pad");
var gameMaster = require('@data/GAME_MASTER.json');
/**
 * Parses the pokemon forms from the item templates for each pokemon
 */
var Forms = /** @class */ (function () {
    function Forms() {
    }
    /**
     * Sets any additional forms the pokemon may have
     */
    Forms.prototype.Process = function (pokemon, rawPokemon) {
        var forms = this.getForms(gameMaster, rawPokemon);
        pokemon.forms = forms;
        return pokemon;
    };
    Forms.prototype.getForms = function (gameMaster, rawPokemon) {
        var _this = this;
        var dex = parseInt(rawPokemon.templateId.split('_')[0].slice(1), 10);
        var dexString = leftPad(dex, 4, '0');
        var formKey = "FORMS_V" + dexString + "_POKEMON_" + rawPokemon.pokemonSettings.pokemonId;
        var itemTemplate = gameMaster
            .itemTemplates
            .find(function (itemTemplate) {
            return itemTemplate.templateId === formKey;
        });
        var forms = [];
        if (itemTemplate && itemTemplate.formSettings && itemTemplate.formSettings.forms) {
            itemTemplate.formSettings.forms.forEach(function (f) {
                var formName = _this.removeSuffixIfNeeded(f.form);
                forms.push({
                    id: formName,
                    name: _util_1.Util.SnakeCase2HumanReadable(formName)
                });
            });
        }
        return forms;
    };
    Forms.prototype.removeSuffixIfNeeded = function (name) {
        var normalSuffix = '_NORMAL';
        var normalIndex = name.indexOf(normalSuffix);
        if (normalIndex >= 0) {
            name = name.substring(0, normalIndex);
        }
        return name;
    };
    Forms = __decorate([
        pipeline_1.Component({
            pipeline: 'pokemon'
        })
    ], Forms);
    return Forms;
}());
exports.Forms = Forms;
//# sourceMappingURL=forms.js.map