import { IComponent } from '@core/pipeline';
import { ItemTemplate } from '@income';
import { Pokemon } from '@outcome/pokemon';
export declare class MaxCP implements IComponent {
    /**
     * Calculates the maximum CP amount of the given
     * Stamina, Attack and Defense values.
     * Formula source: https://www.reddit.com/r/TheSilphRoad/comments/4t7r4d/exact_pokemon_cp_formula/
     *
     * @param {Number} baseStamina The base stamina of the Pokemon
     * @param {Number} baseAttack The base attack of the Pokemon
     * @param {Number} baseDefense The base defemse of the Pokemon
     *
     * @returns {Number} The maximum CP amount of the given values
     */
    Calculate(baseStamina: number, baseAttack: number, baseDefense: number): number;
    /**
     * Calculates the max CP of a Pokemon
     */
    Process(pokemon: Pokemon, rawPokemon: ItemTemplate): Pokemon;
}
