import { Pipeline } from '@core/pipeline';
import { RootObject, ItemTemplate } from '@income';
import { Identifyable } from '@core';
/**
 * Represents the Pipeline which converts Game Master Pokemon related
 * input data to Pokemon models
 */
export declare class PokemonPipeline extends Pipeline {
    private readonly pokemonRegex;
    private readonly specialMasterFiles;
    constructor(input: RootObject, special: RootObject[]);
    private isPokemon;
    private isNormalPokemon;
    /**
     * Checks if the given ItemTemplate is indeed a Pokemon
     */
    isItemTemplate(item: ItemTemplate): boolean;
    Run(): Promise<Object[]>;
}
export interface IdentifiableMove extends Identifyable {
    legacy: boolean;
}
