"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var pipeline_1 = require("@core/pipeline");
var p_iteration_1 = require("p-iteration");
var _ = require("lodash");
var _util_1 = require("@util");
/**
 * Represents the Pipeline which converts Game Master Pokemon related
 * input data to Pokemon models
 */
var PokemonPipeline = /** @class */ (function (_super) {
    __extends(PokemonPipeline, _super);
    function PokemonPipeline(input, special) {
        var _this = _super.call(this, input, 'pokemon') || this;
        _this.pokemonRegex = '^(V[0-9]+_POKEMON_?.*)';
        _this.specialMasterFiles = special;
        return _this;
    }
    PokemonPipeline.prototype.isPokemon = function (templateId) {
        return new RegExp('^(V[0-9]+_POKEMON_?.*)', 'g').test(templateId);
    };
    PokemonPipeline.prototype.isNormalPokemon = function (templateId) {
        return new RegExp('^(V[0-9]+_POKEMON_?.*_NORMAL)', 'g').test(templateId);
    };
    /**
     * Checks if the given ItemTemplate is indeed a Pokemon
     */
    PokemonPipeline.prototype.isItemTemplate = function (item) {
        var id = item.templateId;
        return this.isPokemon(id) && !this.isNormalPokemon(id);
    };
    PokemonPipeline.prototype.Run = function () {
        return __awaiter(this, void 0, void 0, function () {
            var pokemonData, specialInputs, legacyMoveComponents;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _super.prototype.Run.call(this)];
                    case 1:
                        pokemonData = _a.sent();
                        return [4 /*yield*/, p_iteration_1.map(this.specialMasterFiles, function (input) { return input.itemTemplates.filter(function (p) { return _this.isItemTemplate(p); }); })];
                    case 2:
                        specialInputs = _a.sent();
                        legacyMoveComponents = [new LegacyQuickMoves(), new LegacyCinematicMoves()];
                        return [4 /*yield*/, p_iteration_1.forEachSeries(specialInputs, function (specialInput) { return __awaiter(_this, void 0, void 0, function () {
                                var _this = this;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, p_iteration_1.forEachSeries(specialInput, function (itemTemplate) { return __awaiter(_this, void 0, void 0, function () {
                                                var currentPokemon;
                                                return __generator(this, function (_a) {
                                                    switch (_a.label) {
                                                        case 0:
                                                            currentPokemon = pokemonData.find(function (value) { return value.id === itemTemplate.pokemonSettings.pokemonId; });
                                                            return [4 /*yield*/, p_iteration_1.forEachSeries(legacyMoveComponents, function (component) { return component.Process(currentPokemon, itemTemplate); })];
                                                        case 1:
                                                            _a.sent();
                                                            return [2 /*return*/];
                                                    }
                                                });
                                            }); })];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            }); })];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, pokemonData];
                }
            });
        });
    };
    return PokemonPipeline;
}(pipeline_1.Pipeline));
exports.PokemonPipeline = PokemonPipeline;
var LegacyMove = /** @class */ (function () {
    function LegacyMove(moveType) {
        this.moveType = moveType;
    }
    LegacyMove.prototype.Process = function (pokemon, rawPokemon) {
        var _this = this;
        var specialMoves = _
            .chain(rawPokemon.pokemonSettings[this.moveType])
            .uniq()
            .map(_util_1.Util.SnakeCase2Identifyable)
            .filter(function (maybeSpecialMove) { return pokemon[_this.moveType].find(function (move) { return move.id === maybeSpecialMove.id; }) === undefined; })
            .map(LegacyMove.ToLegacyMove)
            .value();
        pokemon[this.moveType] = pokemon[this.moveType].concat(specialMoves);
        return pokemon;
    };
    LegacyMove.ToLegacyMove = function (move) {
        return {
            name: move.name,
            id: move.id,
            legacy: true
        };
    };
    return LegacyMove;
}());
var LegacyCinematicMoves = /** @class */ (function (_super) {
    __extends(LegacyCinematicMoves, _super);
    function LegacyCinematicMoves() {
        return _super.call(this, 'cinematicMoves') || this;
    }
    return LegacyCinematicMoves;
}(LegacyMove));
var LegacyQuickMoves = /** @class */ (function (_super) {
    __extends(LegacyQuickMoves, _super);
    function LegacyQuickMoves() {
        return _super.call(this, 'quickMoves') || this;
    }
    return LegacyQuickMoves;
}(LegacyMove));
//# sourceMappingURL=pokemonPipeline.js.map