"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
describe('Locales Output', function () {
    var pokemons;
    var translations;
    beforeEach(function () {
        pokemons = require('../../output/pokemon.json');
        var locales = ['de-DE', 'en-US', 'zh-TW', 'fr-FR', 'es-ES', 'ja-JP', 'it-IT', 'ko-KR', 'pt-BR'];
        translations = locales.map(function (local) { return require('../../output/locales/' + local + '/pokemon.json'); });
    });
    it('should have a key for each pokemon', function () {
        // TODO: ADD TEST AS SOON AS https://github.com/ZeChrales/PogoAssets/issues/14 IS FIXED
        // translations.forEach(translation => expect(Object.keys(translation).length).to.equal(pokemons.length))
    });
    it('should display bisasam in german translation', function () {
        chai_1.expect(translations[0].BULBASAUR.name).to.equal('Bisasam');
    });
    it('should have the correct description for bulbasaur german translation', function () {
        chai_1.expect(translations[0].BULBASAUR.description).to.equal('Bisasam macht gern einmal ein Nickerchen im Sonnenschein. Auf seinem Rücken trägt es einen Samen. Indem es Sonnenstrahlen aufsaugt, wird der Samen zunehmend größer.');
    });
    it('should have the correct category for bulbasaur', function () {
        chai_1.expect(translations[0].BULBASAUR.category).to.equal('Samen-Pokémon');
    });
});
//# sourceMappingURL=pokemon.js.map